gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.TreeModelFilter

Contents

- Exported types
- Methods
  - clearCache
  - convertChildIterToIter
  - convertChildPathToPath
  - convertIterToChildIter
  - convertPathToChildPath
  - getModel
  - refilter
  - setModifyFunc
  - setVisibleColumn
  - setVisibleFunc
- Properties
  - childModel
  - virtualRoot

Description

A `GtkTreeModel` which hides parts of an underlying tree model

A `GtkTreeModelFilter` is a tree model which wraps another tree model, and can do the following things:

- Filter specific rows, based on data from a “visible column”, a column storing booleans indicating whether the row should be filtered or not, or based on the return value of a “visible function”, which gets a model, iter and user_data and returns a boolean indicating whether the row should be filtered or not.
- Modify the “appearance” of the model, using a modify function. This is extremely powerful and allows for just changing some values and also for creating a completely different model based on the given child model.
- Set a different root node, also known as a “virtual root”. You can pass in a `GtkTreePath` indicating the root node for the filter at construction time.

The basic API is similar to `GtkTreeModelSort`. For an example on its usage, see the section on `GtkTreeModelSort`.

When using `GtkTreeModelFilter`, it is important to realize that `GtkTreeModelFilter` maintains an internal cache of all nodes which are visible in its clients. The cache is likely to be a subtree of the tree exposed by the child model. `GtkTreeModelFilter` will not cache the entire child model when unnecessary to not compromise the caching mechanism that is exposed by the reference counting scheme. If the child model implements reference counting, unnecessary signals may not be emitted because of reference counting rule 3, see the `GtkTreeModel` documentation. (Note that e.g. `GtkTreeStore` does not implement reference counting and will always emit all signals, even when the receiving node is not visible).

Because of this, limitations for possible visible functions do apply. In general, visible functions should only use data or properties from the node for which the visibility state must be determined, its siblings or its parents. Usually, having a dependency on the state of any child node is not possible, unless references are taken on these explicitly. When no such reference exists, no signals may be received for these child nodes (see reference counting rule number 3 in the `GtkTreeModel` section).

Determining the visibility state of a given node based on the state of its child nodes is a frequently occurring use case. Therefore, `GtkTreeModelFilter` explicitly supports this. For example, when a node does not have any children, you might not want the node to be visible. As soon as the first row is added to the node’s child level (or the last row removed), the node’s visibility should be updated.

This introduces a dependency from the node on its child nodes. In order to accommodate this, `GtkTreeModelFilter` must make sure the necessary signals are received from the child model. This is achieved by building, for all nodes which are exposed as visible nodes to `GtkTreeModelFilter`'s clients, the child level (if any) and take a reference on the first node in this level. Furthermore, for every row-inserted, row-changed or row-deleted signal (also these which were not handled because the node was not cached), `GtkTreeModelFilter` will check if the visibility state of any parent node has changed.

Beware, however, that this explicit support is limited to these two cases. For example, if you want a node to be visible only if two nodes in a child’s child level (2 levels deeper) are visible, you are on your own. In this case, either rely on `GtkTreeStore` to emit all signals because it does not implement reference counting, or for models that do implement reference counting, obtain references on these child levels yourself.

Synopsis

- newtype TreeModelFilter = TreeModelFilter (ManagedPtr TreeModelFilter)
- class (GObject o, IsDescendantOf TreeModelFilter o) => IsTreeModelFilter o
- toTreeModelFilter :: (MonadIO m, IsTreeModelFilter o) => o -> m TreeModelFilter
- treeModelFilterClearCache :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> m ()
- treeModelFilterConvertChildIterToIter :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> TreeIter -> m (Bool, TreeIter)
- treeModelFilterConvertChildPathToPath :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> TreePath -> m (Maybe TreePath)
- treeModelFilterConvertIterToChildIter :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> TreeIter -> m TreeIter
- treeModelFilterConvertPathToChildPath :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> TreePath -> m (Maybe TreePath)
- treeModelFilterGetModel :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> m TreeModel
- treeModelFilterRefilter :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> m ()
- treeModelFilterSetModifyFunc :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> [GType] -> TreeModelFilterModifyFunc -> m ()
- treeModelFilterSetVisibleColumn :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> Int32 -> m ()
- treeModelFilterSetVisibleFunc :: (HasCallStack, MonadIO m, IsTreeModelFilter a) => a -> TreeModelFilterVisibleFunc -> m ()
- constructTreeModelFilterChildModel :: (IsTreeModelFilter o, MonadIO m, IsTreeModel a) => a -> m (GValueConstruct o)
- getTreeModelFilterChildModel :: (MonadIO m, IsTreeModelFilter o) => o -> m (Maybe TreeModel)
- constructTreeModelFilterVirtualRoot :: (IsTreeModelFilter o, MonadIO m) => TreePath -> m (GValueConstruct o)
- getTreeModelFilterVirtualRoot :: (MonadIO m, IsTreeModelFilter o) => o -> m (Maybe TreePath)

# Exported types

newtype TreeModelFilter Source #

Memory-managed wrapper type.

Constructors

TreeModelFilter (ManagedPtr TreeModelFilter) |

#### Instances

Instances details

Eq TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter Methods (==) :: TreeModelFilter -> TreeModelFilter -> Bool Source # (/=) :: TreeModelFilter -> TreeModelFilter -> Bool Source #
GObject TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter
ManagedPtrNewtype TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter Methods toManagedPtr :: TreeModelFilter -> ManagedPtr TreeModelFilter Source #
TypedObject TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter Methods glibType :: IO GType Source #
HasParentTypes TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter
IsGValue (Maybe TreeModelFilter) Source # | Convert `TreeModelFilter` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.TreeModelFilter Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TreeModelFilter -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TreeModelFilter) Source #
type ParentTypes TreeModelFilter Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter type ParentTypes TreeModelFilter = '[Object, TreeDragSource, TreeModel]

class (GObject o, IsDescendantOf TreeModelFilter o) => IsTreeModelFilter o Source #

Type class for types which can be safely cast to `TreeModelFilter`, for instance with `toTreeModelFilter`.

#### Instances

Instances details

(GObject o, IsDescendantOf TreeModelFilter o) => IsTreeModelFilter o Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelFilter

toTreeModelFilter :: (MonadIO m, IsTreeModelFilter o) => o -> m TreeModelFilter Source #

Cast to `TreeModelFilter`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, clearCache, convertChildIterToIter, convertChildPathToPath, convertIterToChildIter, convertPathToChildPath, dragDataDelete, dragDataGet, filterNew, forceFloating, foreach, freezeNotify, getv, isFloating, iterChildren, iterHasChild, iterNChildren, iterNext, iterNthChild, iterParent, iterPrevious, notify, notifyByPspec, ref, refNode, refSink, refilter, rowChanged, rowDeleted, rowDraggable, rowHasChildToggled, rowInserted, rowsReordered, runDispose, stealData, stealQdata, thawNotify, unref, unrefNode, watchClosure.

#### Getters

getColumnType, getData, getFlags, getIter, getIterFirst, getIterFromString, getModel, getNColumns, getPath, getProperty, getQdata, getStringFromIter, getValue.

#### Setters

setData, setDataFull, setModifyFunc, setProperty, setVisibleColumn, setVisibleFunc.

## clearCache

treeModelFilterClearCache Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> m () |

Deprecated: (Since version 4.10)

This function should almost never be called. It clears the `filter` of any cached iterators that haven’t been reffed with `treeModelRefNode`. This might be useful if the child model being filtered is static (and doesn’t change often) and there has been a lot of unreffed access to nodes. As a side effect of this function, all unreffed iters will be invalid.

## convertChildIterToIter

treeModelFilterConvertChildIterToIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> TreeIter | `childIter`: A valid `GtkTreeIter` pointing to a row on the child model.
-> m (Bool, TreeIter) | Returns: `True`, if `filterIter` was set, i.e. if `childIter` is a valid iterator pointing to a visible row in child model.

Deprecated: (Since version 4.10)

Sets `filterIter` to point to the row in `filter` that corresponds to the row pointed at by `childIter`. If `filterIter` was not set, `False` is returned.

## convertChildPathToPath

treeModelFilterConvertChildPathToPath Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> TreePath | `childPath`: A `GtkTreePath` to convert.
-> m (Maybe TreePath) | Returns: A newly allocated `GtkTreePath`

Deprecated: (Since version 4.10)

Converts `childPath` to a path relative to `filter`. That is, `childPath` points to a path in the child model. The rerturned path will point to the same row in the filtered model. If `childPath` isn’t a valid path on the child model or points to a row which is not visible in `filter`, then `Nothing` is returned.

## convertIterToChildIter

treeModelFilterConvertIterToChildIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> TreeIter | `filterIter`: A valid `GtkTreeIter` pointing to a row on `filter`.
-> m TreeIter |

Deprecated: (Since version 4.10)

Sets `childIter` to point to the row pointed to by `filterIter`.

## convertPathToChildPath

treeModelFilterConvertPathToChildPath Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> TreePath | `filterPath`: A `GtkTreePath` to convert.
-> m (Maybe TreePath) | Returns: A newly allocated `GtkTreePath`

Deprecated: (Since version 4.10)

Converts `filterPath` to a path on the child model of `filter`. That is, `filterPath` points to a location in `filter`. The returned path will point to the same location in the model not being filtered. If `filterPath` does not point to a location in the child model, `Nothing` is returned.

## getModel

treeModelFilterGetModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> m TreeModel | Returns: A pointer to a `GtkTreeModel`

Deprecated: (Since version 4.10)

Returns a pointer to the child model of `filter`.

## refilter

treeModelFilterRefilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> m () |

Deprecated: (Since version 4.10)

Emits row_changed for each row in the child model, which causes the filter to re-evaluate whether a row is visible or not.

## setModifyFunc

treeModelFilterSetModifyFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> [GType] | `types`: The `GType`s of the columns.
-> TreeModelFilterModifyFunc | `func`: A `GtkTreeModelFilterModifyFunc`
-> m () |

Deprecated: (Since version 4.10)

With the `nColumns` and `types` parameters, you give an array of column types for this model (which will be exposed to the parent model/view). The `func`, `data` and `destroy` parameters are for specifying the modify function. The modify function will get called for each data access, the goal of the modify function is to return the data which should be displayed at the location specified using the parameters of the modify function.

Note that `treeModelFilterSetModifyFunc` can only be called once for a given filter model.

## setVisibleColumn

treeModelFilterSetVisibleColumn Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> Int32 | `column`: A `int` which is the column containing the visible information
-> m () |

Deprecated: (Since version 4.10)

Sets `column` of the child_model to be the column where `filter` should look for visibility information. `columns` should be a column of type `G_TYPE_BOOLEAN`, where `True` means that a row is visible, and `False` if not.

Note that `treeModelFilterSetVisibleFunc` or `treeModelFilterSetVisibleColumn` can only be called once for a given filter model.

## setVisibleFunc

treeModelFilterSetVisibleFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelFilter a) |
=> a | `filter`: A `GtkTreeModelFilter`
-> TreeModelFilterVisibleFunc | `func`: A `GtkTreeModelFilterVisibleFunc`, the visible function
-> m () |

Deprecated: (Since version 4.10)

Sets the visible function used when filtering the `filter` to be `func`. The function should return `True` if the given row should be visible and `False` otherwise.

If the condition calculated by the function changes over time (e.g. because it depends on some global parameters), you must call `treeModelFilterRefilter` to keep the visibility information of the model up-to-date.

Note that `func` is called whenever a row is inserted, when it may still be empty. The visible function should therefore take special care of empty rows, like in the example below.

### c code

    static gboolean
    visible_func (GtkTreeModel *model,
                  GtkTreeIter  *iter,
                  gpointer      data)
    {
      // Visible if row is non-empty and first column is “HI”
      char *str;
      gboolean visible = FALSE;

      gtk_tree_model_get (model, iter, 0, &str, -1);
      if (str && strcmp (str, "HI") == 0)
        visible = TRUE;
      g_free (str);

      return visible;
    }

Note that `treeModelFilterSetVisibleFunc` or `treeModelFilterSetVisibleColumn` can only be called once for a given filter model.

# Properties

## childModel

The child model of the tree model filter.

constructTreeModelFilterChildModel :: (IsTreeModelFilter o, MonadIO m, IsTreeModel a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`child-model`” property. This is rarely needed directly, but it is used by `new`.

getTreeModelFilterChildModel :: (MonadIO m, IsTreeModelFilter o) => o -> m (Maybe TreeModel) Source #

Get the value of the “`child-model`” property. When overloading is enabled, this is equivalent to

    get treeModelFilter #childModel

## virtualRoot

The virtual root of the tree model filter.

constructTreeModelFilterVirtualRoot :: (IsTreeModelFilter o, MonadIO m) => TreePath -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`virtual-root`” property. This is rarely needed directly, but it is used by `new`.

getTreeModelFilterVirtualRoot :: (MonadIO m, IsTreeModelFilter o) => o -> m (Maybe TreePath) Source #

Get the value of the “`virtual-root`” property. When overloading is enabled, this is equivalent to

    get treeModelFilter #virtualRoot